VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "MSWINSCK.OCX"
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "RICHTX32.OCX"
Begin VB.Form frmMain 
   Caption         =   "T3 Online"
   ClientHeight    =   7095
   ClientLeft      =   165
   ClientTop       =   450
   ClientWidth     =   9480
   Icon            =   "frmMain.frx":0000
   ScaleHeight     =   7095
   ScaleWidth      =   9480
   StartUpPosition =   2  'CenterScreen
   Begin MSWinsockLib.Winsock sckMain 
      Left            =   4020
      Top             =   4920
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin VB.TextBox txtCommand 
      Height          =   315
      Left            =   1740
      TabIndex        =   7
      Top             =   6720
      Width           =   7695
   End
   Begin RichTextLib.RichTextBox rtfLog 
      Height          =   1455
      Left            =   60
      TabIndex        =   6
      Top             =   5220
      Width           =   9375
      _ExtentX        =   16536
      _ExtentY        =   2566
      _Version        =   393217
      BorderStyle     =   0
      ReadOnly        =   -1  'True
      ScrollBars      =   2
      TextRTF         =   $"frmMain.frx":000C
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
   Begin VB.Frame framStatus 
      Height          =   5175
      Left            =   60
      TabIndex        =   1
      Top             =   -60
      Width           =   4095
      Begin VB.CheckBox chkDebugRow 
         Caption         =   "Debug row checking"
         Height          =   195
         Left            =   240
         TabIndex        =   9
         Top             =   4740
         Width           =   1815
      End
      Begin VB.Label lblCurrentPlayerStat 
         Caption         =   "Current player"
         Height          =   195
         Left            =   180
         TabIndex        =   5
         Top             =   360
         Width           =   1155
      End
      Begin VB.Label lblCurrentPlayer 
         BorderStyle     =   1  'Fixed Single
         Caption         =   "Player 1"
         Height          =   255
         Left            =   1380
         TabIndex        =   4
         Top             =   300
         Width           =   2475
      End
      Begin VB.Label lblCurrentTurnStat 
         Caption         =   "Current turn"
         Height          =   195
         Left            =   180
         TabIndex        =   3
         Top             =   660
         Width           =   1155
      End
      Begin VB.Label lblCurrentTurn 
         BorderStyle     =   1  'Fixed Single
         Caption         =   "1"
         BeginProperty DataFormat 
            Type            =   1
            Format          =   "0"
            HaveTrueFalseNull=   0
            FirstDayOfWeek  =   0
            FirstWeekOfYear =   0
            LCID            =   1043
            SubFormatType   =   1
         EndProperty
         Height          =   255
         Left            =   1380
         TabIndex        =   2
         Top             =   600
         Width           =   615
      End
   End
   Begin VB.PictureBox picBoard 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00000000&
      DrawWidth       =   4
      Height          =   5100
      Left            =   4260
      ScaleHeight     =   336
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   340
      TabIndex        =   0
      Top             =   0
      Width           =   5160
   End
   Begin VB.Label lblChat 
      Caption         =   "Message\command"
      Height          =   195
      Left            =   120
      TabIndex        =   8
      Top             =   6780
      Width           =   1455
   End
   Begin VB.Menu mnuGame 
      Caption         =   "&Game"
      Begin VB.Menu mnuGameNew 
         Caption         =   "&New"
         Shortcut        =   ^N
      End
      Begin VB.Menu mnuGameEnd 
         Caption         =   "&End"
         Shortcut        =   ^E
      End
      Begin VB.Menu mnuGameSep1 
         Caption         =   "-"
      End
      Begin VB.Menu mnGameExit 
         Caption         =   "E&xit"
         Shortcut        =   ^Q
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Option Compare Binary
Option Base 0


' Debugging mode enable\disable
Private Sub chkDebugRow_Click()

    WinDebug = CBool(chkDebugRow.Value)
    
    ' Redraw the board to erase previous debug garbage
    If WinDebug = False Then modBoard.Draw

End Sub


' Setup a new game by default
Private Sub Form_Load()

    ' Initialise the log module
    modLog.Init frmMain.rtfLog
    
    ' Initialise the net module (even though it might not be necessary :^) )
    modNet.Init sckMain
    
    ' Immediately set up a new game
    modGame.NewGame
    Me.UpdateStatus

End Sub


' Stupid VB resizing event
Private Sub Form_Paint()

    Form_Resize
    modBoard.Draw

End Sub


' Form resizing code
Private Sub Form_Resize()

    ' Ignore resizing errors
    On Error Resume Next
    
    
    ' Don't allow too small sizes
    If Me.Width < 6000 Then
        Me.Width = 6000
        Exit Sub
    End If
    If Me.Height < 5610 Then
        Me.Height = 5610
        Exit Sub
    End If
    
    ' Board
    picBoard.Width = (BoardWidth * CellSize) * 15
    picBoard.Left = framStatus.Width + (15 * 14)
    picBoard.Height = framStatus.Height - (15 * 4)
    
    ' Adjust cell sizes
    CellSize = CInt(picBoard.ScaleHeight / BoardWidth)
    CellBorderSize = (CellSize / 32) + 1
    
    ' Status frame
    framStatus.Width = Me.Width - ((BoardWidth * CellSize) * 15) - (15 * 26)
    framStatus.Height = Me.Height - (15 * 174)
    
    ' Status frame contents
    lblCurrentPlayer.Width = framStatus.Width - (15 * 104)
    chkDebugRow.Top = (framStatus.Top + framStatus.Height) - (15 * 24)
    
    ' Log
    rtfLog.Top = picBoard.Height + (15 * 8)
    rtfLog.Width = Me.Width - (15 * 15)
    txtCommand.Width = rtfLog.Width - lblChat.Width - (15 * 15)
    txtCommand.Top = rtfLog.Top + rtfLog.Height + (15 * 2)
    lblChat.Top = rtfLog.Top + rtfLog.Height + (15 * 6)
    
End Sub


' Call program shutdown code (then unload itself)
Private Sub Form_Unload(Cancel As Integer)

    modMain.Shutdown

End Sub


' Query a form unload instead
Private Sub mnGameExit_Click()

    Form_Unload 0

End Sub


' The user wants to start a new game
Private Sub mnuGameNew_Click()

    modGame.NewGame

End Sub


' Send cell clicks to modGame
Private Sub picBoard_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)

    Dim CellX As Integer
    Dim CellY As Integer
    Dim ReturnValue As Integer
    
    
    ' Do nothing if the game is inactive
    If GameActive = False Then
        modUtil.PlayStyleSound "no.wav"
        Exit Sub
    End If
    
    ' Calculate the cell that got clicked
    CellX = CInt(X \ CellSize)
    CellY = CInt(Y \ CellSize)
    
    ' Send the data to the game module
    ReturnValue = modGame.CellClick(CellX, CellY)
    
    ' Did it go allright?
    If ReturnValue = GameError.InvalidCell Then
        modUtil.PlayStyleSound "no.wav"
        Exit Sub
    End If
    
    ' Advance a turn
    If GameActive = True Then
        modGame.AdvanceTurn
        UpdateStatus
    End If

End Sub


' Update the captions\texts in the status frame
Public Sub UpdateStatus()

    lblCurrentPlayer.Caption = Player(PlayerTurn).Name
    lblCurrentTurn.Caption = Turn + 1
    
End Sub


' Socket event rerouters
Private Sub sckMain_ConnectionRequest(ByVal requestID As Long)

    modNet.ConnectionRequest requestID

End Sub

Private Sub sckMain_DataArrival(ByVal bytesTotal As Long)

    Dim Data As String
    
    sckMain.GetData Data
    modNet.DataArrival Data

End Sub


' Halt all form actions until further notice
Public Sub Suspend()

    mnuGame.Enabled = False

End Sub


' Continue form actions
Public Sub Continue()

    mnuGame.Enabled = True

End Sub


' Process a chat line\command
Private Sub txtCommand_KeyPress(KeyAscii As Integer)

    If KeyAscii = 13 Then
        modNet.SendRaw LocalName & ":" & Chr$(9) & txtCommand.Text
        modLog.WriteMsg LocalName & ":" & Chr$(9) & txtCommand.Text
        txtCommand.Text = ""
    End If

End Sub
